<script lang="ts">
import Vue from 'vue';
import { CarouselWrap } from '../common/index.vue';
import {
  SlpArrowCircularLeft,
  SlpArrowCircularRight,
} from '../solutions/index.vue';
import CaseStudyCard from './casestudy-card.vue';

export default Vue.extend({
  name: 'CustomersCarousel',
  components: {
    CarouselWrap,
    CaseStudyCard,
    SlpArrowCircularLeft,
    SlpArrowCircularRight,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <div class="container">
    <SlpTypography v-if="data.title" tag="h2" variant="heading3"
      >{{ data.title }}
    </SlpTypography>
    <CarouselWrap ref="carousel" :items="data.studies">
      <template v-if="data.studies.length > 3" #floating>
        <button
          class="btn btn__prev"
          aria-label="Previous"
          @click="$refs.carousel.prev()"
        >
          <SlpArrowCircularLeft />
        </button>
        <button
          class="btn btn__next"
          aria-label="Next"
          @click="$refs.carousel.next()"
        >
          <SlpArrowCircularRight />
        </button>
      </template>

      <template #content>
        <template v-if="$refs.carousel">
          <div
            v-for="cardNumber in $refs.carousel.itemIndexes"
            :key="cardNumber"
            class="card"
          >
            <CaseStudyCard :data="data.studies[cardNumber]" />
          </div>
        </template>
      </template>
    </CarouselWrap>
  </div>
</template>

<style lang="scss" scoped>
.slp-text-heading3 {
  text-align: center;
  margin-bottom: $spacing-24;

  @media (max-width: 768px) {
    font-size: $text-heading-2-mobile;
  }
}

.container {
  width: 100%;
  position: relative;
}

.card {
  flex: 0 0 380px;
  display: inline-flex;

  @media (max-width: 461px) {
    flex: 0 0 300px;
  }
}

.btn {
  border: none;
  z-index: 89;
  outline: none;
  position: absolute;
  top: 43%;
  cursor: pointer;

  &__prev {
    left: 4px;
  }

  &__next {
    right: -4px;
  }
}
</style>
